/****
 *
 * Este programa demonstra o retorno
 * incorreto de um ponteiro incrementado
 *
 ****/

#include <stdio.h>
#include <string.h>

/****
 *
 * CopiaString(): Esta funo deveria imitar strcpy()
 *                mas est implementada incorretamente
 *
 * Argumento: destino (sada) - o array que recebe
 *                              a cpia
 *            origem (entrada) - o string que  copiado
 *
 * Retorno: string contendo a cpia (i.e., deveria ser)
 *
 ****/
char *CopiaString(char *destino, const char *origem)
{
   while (*destino++ = *origem++)
      ; /* Intencionalmente vazio */

      /* A cpia do string foi perfeita,     */
      /* mas o retorno  um desastre porque  */
      /* o ponteiro 'destino' no est       */
      /* apontando para o string copiado no  */
      /* array (primeiro parmetro).         */
   return destino;
}

int main()
{
   char *p, str[30];

      /* Usar a funo CopiaString() */
      /* como a seguir no apresenta */
      /* nenhum problema:            */
   CopiaString(str, "bola");

   printf("\nString copiado: \"%s\"", str);

      /* Usar a funo CopiaString() */
      /* como a seguir representa    */
      /* um problema:                */
   p = CopiaString(str, "problema");

   printf("\nString copiado: \"%s\"", p);

      /* O pior ocorre agora: o resultado da   */
      /* concatenao caberia confortavelmente */
      /* no array str se p apontasse para o    */
      /* inicio do array, mas no  o caso     */
   strcat(p, " com Tiranossauro Rex");

   printf("\nString concatenado: \"%s\"\n", p);

   return 0;
}

/*

Resultado do programa no Windows XP:

String copiado: "bola"
String copiado: "-+w-wP$>"
String concatenado: "F+w"

*/
