/****
 *
 * Este programa demonstra o retorno
 * correto de um ponteiro incrementado
 *
 ****/

#include <stdio.h>
#include <string.h>

/****
 *
 * CopiaString2(): Esta funo imita strcpy()
 *
 * Argumento: destino (sada) - o array que recebe
 *                              a cpia
 *            origem (entrada) - o string que  copiado
 *
 * Retorno: string contendo a cpia
 *
 ****/

char *CopiaString2(char *destino, const char *origem)
{
   char *inicio = destino;

   while (*destino++ = *origem++)
      ; /* Intencionalmente vazio */

   return inicio;
}

int main()
{
   char *p, str[30];

      /* Usar a funo CopiaString2() */
      /* como a seguir no apresenta */
      /* nenhum problema:            */
   CopiaString2(str, "bola");

   printf("\nString copiado: \"%s\"", str);

      /* Usar a funo CopiaString2() */
      /* como a seguir representa    */
      /* um problema:                */
   p = CopiaString2(str, "problema");

   printf("\nString copiado: \"%s\"", p);

      /* O pior ocorre agora: o resultado da   */
      /* concatenao caberia confortavelmente */
      /* no array str se p apontasse para o    */
      /* inicio do array, mas no  o caso     */
   strcat(p, " com Tiranossauro Rex");

   printf("\nString concatenado: \"%s\"\n", p);

   return 0;
}

/*

Resultado do programa no Windows XP:

String copiado: "bola"
String copiado: "problema"
String concatenado: "problema com Tiranossauro Rex"

*/
