/****************************/
/* Exemplo de uso de vscanf */
/****************************/

#include <stdio.h>
#include <stdarg.h>

/****
 *
 * Funo LeituraComPrompt(): incorpora apresentao de prompt
 *                            com entrada de dados em stdin
 *
 * Argumentos: prompt (entrada) - a mensagem a ser apresentada
 *                                ao usurio em stdout
 *             formato (entrada) - string de formatao
 *             ... (sada) - endereos de variveis
 *
 * Retorno: o mesmo que scanf()
 *
 ****/

int LeituraComPrompt( const char *prompt,
                      const char *formato, ... )
{
   int     nValoresAtribuidos;
   va_list args;

      /* Apresenta o prompt para o usurio */
   printf(prompt);
   fflush(stdout);

      /* Delega a tarefa restante para vscanf() */
   va_start(args, formato);
   nValoresAtribuidos = vscanf(formato, args);
   va_end(args);

   return nValoresAtribuidos;
}

int main(void)
{
   int   umInt, nValores;
   float umFloat;

   nValores = LeituraComPrompt( "\nDigite um inteiro e "
                                "um real: ", "%d %f",
                                &umInt, &umFloat );

   printf( "Numero de valores lidos e atribuidos: %d\n",
           nValores );

   return 0;
}
